<template>
  <div>
    <PageCard
      class="pageCard-padding background-header"
      :bordering="false"
      fontWeight="bold"
      titleSize=".925rem"
      :title="$t('deposit.payByCrypto.title')">
    </PageCard>
    <PageCard
      :bordering="false">
      <div class="searching">
        <div class="searching-text searching-title">{{$t('deposit.payByCrypto.buyAnyCrypto')}}</div>
        <div class="searching-text searching-subtitle">{{$t('deposit.payByCrypto.muchCheaper')}}</div>
        <div class="searching-block">
          <BInput
            class="mt-15"
            :label="$t('deposit.search')"
            v-model="search"></BInput>
        </div>
      </div>
      <agile
        v-if="opened"
        ref="slider"
        :centerMode="true"
        :centerPadding="34"
        :options="carouselOptions"
        class="carousel pt-25 pb-25">
        <div
          v-for="(item, key) in currencyList"
          :key="key"
          class="carousel_slide">
          <div class="swiper_container">
            <div
              class="swiper_container-item"
              v-for="(curr, ckey) in item"
              @click="select(curr)"
              :key="ckey">
              <div
                class="swiper_tapper"
                :class="{active: active===curr.ticker}">
                <div class="swiper_tapper-img swiper-slide">
                  <img
                    class="swiper_tapper-img-item swiper-lazy"
                    :src="curr.image"
                    :alt="curr.ticker">
                </div>
                <div class="swiper_tapper-title">
                  <div class="swiper_tapper-title-ticker">{{curr.ticker}}</div>
                  <div class="swiper_tapper-title-name">{{curr.name}}</div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <template slot="prevButton">
          <div class="carousel_button carousel_button-left"></div>
        </template>
        <template slot="nextButton">
          <div class="carousel_button carousel_button-right"></div>
        </template>
      </agile>
    </PageCard>
  </div>
</template>

<script>
  import PageCard from '~/components/UI/PageCard';
  import BInput from '~/components/UI/Input_search';
  import 'swiper/css/swiper.css'
  import {VueAgile} from 'vue-agile';

  const chunkArray = (myArray, chunk_size) => {
    let index = 0;
    let arrayLength = myArray.length;
    let tempArray = [];

    for (index = 0; index < arrayLength; index += chunk_size) {
      let myChunk = myArray.slice(index, index + chunk_size);
      tempArray.push(myChunk);
    }

    return tempArray;
  };

  export default {
    name: "Step1",
    data() {
      return {
        carouselOptions: {
          infinitie: true,
          initialSlide: 0,
          dots: true,
          slidesToShow: 1
        },
        active: '',
        search: '',
        opened: false
      }
    },
    components: {
      PageCard,
      BInput,
      agile: VueAgile
    },
    events: {
      'deposit:opened': async function (event, param) {
        this.$nextTick(_ => {
          const slider = this.$refs['slider'];
          this.opened = true;
          const btc = this.depositList.filter(item => item.ticker === 'btc');
          if (btc && btc.length) {
            this.select(btc[0]);
          }
        });
      }
    },
    computed: {
      depositList() {
        return this.$store.state.deposit.data;
      },
      currencyList() {
        const search = this.search.toLowerCase();
        const filteredData = this.depositList.map(item => {
          if (item.ticker.toLowerCase().indexOf(search.toLowerCase()) > -1 || (item.name.toLowerCase().indexOf(search.toLowerCase()) > -1)) {
            const it = Object.assign({}, item);
            it.name = it.name.split(' ')[0];
            return it
          }
        }).filter(i => i);
        return chunkArray(filteredData, 9);
      },
    },
    methods: {
      select(curr) {
        this.active = curr.ticker;
        this.$emit('select', curr);
      }
    },
    watch: {
      currencyList() {
        this.$nextTick(_ => {
          this.$refs['slider'].reload();
        });
      }
    }
  }
</script>
<style
  lang="scss"
  scoped>
  .searching {
    padding: 20px 40px;
    background-color: #151e2f;
    &-text {
      text-transform: uppercase;
      font-weight: bold;
    }
    &-subtitle {
      color: #36d253;
    }
  }
</style>
